#!/bin/sh
#
# MartiniB #
#
# 2012.04.22 - enable browse last scanned services
# 2012.03.31 - NN2-HD, move Volume/Mute down to able see Menu's and Channel Selection Titles
# 2012.03.31 - search for last backup copy when patcer.sh newer than *.xml
# 2012.03.11 - replace Setup screen in NN2HD skin
# 2012.03.10 - show `Menu  Section  Sub Section` path as window title
# 2012.03.07 - remove Menu Titles duplicates
# 2012.03.03 - yellow EventProgressBar in ChannelSelection
# 2012.02.19 - increase ChannelContextMenu vertical size
# 2012.02.18 - patch every installed skin instead current selected
# 2011.09.22 - add FullEPG(Short+Extended) to EPGSelectionMulti
# 2011.09.22 - replace LT6.HD/fonts/lt6-edc.ttf font where cant see russian and latvian letters
# 2011.07.07 - remove backup copy if md5 checksum same as previous
# 2010.10.24 - fix Help menu
# 2010.06.17 - fix DMConcinnity-HD->SkinSelector
# 2010.06.16 - skip FullEPG when Short and Extended present
# 2010.06.15 - fitted for DMConcinnity-HD
# 2010.04.24 - yellow EventTitle in ChannelSelection
# 2010.04.17 - change ExtendedEPG To FullEPG(Short+Extended) if EventName.py has FULL_DESCRIPTION
# 2010.03.30 - Replace fonts where cant see russian and latvian letters
# 2010.03.18 - AddWrapAround in menu sections
#

SectionsWhereAddWrapAround="
"menu_mainmenu"
"menu_shutdown"
"menu_setup"
"menu_information"
"menu_scan"
"menu_system"
"menu_harddisk"
"menu_shutdown"
"HelpMenu"
"MessageBox"
"ChoiceBox"
"AdapterSetup"
"AdapterSetupConfiguration"
"BouquetSelector"
"ChannelContextMenu"
"NimSelection"
"NimSetup"
"ScanSetup"
"VideoFinetune"
"CrashlogAutoSubmitConfiguration"
"Setup"
"Satfinder"
"ScanSimple"
"SkinSelector"
"PluginBrowser"
"PluginManager"
"NetworkAdapterSelection"
"RecordPathsSettings"
"ParentalControlSetup"
"

ReplaceFonts="
"goodtime.ttf"
"/usr/share/enigma2/LT6.HD/fonts/lt6-edc.ttf"
"/usr/share/enigma2/LT6.HD/fonts/lt6-ps.ttf"
"/usr/share/enigma2/LT6.HD/fonts/lt6-psc.ttf"
"/usr/share/enigma2/LT6.HD/fonts/lt6-psi.ttf"
"/usr/share/enigma2/LT6.HD/fonts/tpb.otf"
"/usr/share/enigma2/DMConcinnity-HD/fonts/HandelGotDBol.ttf"
"ArenaCdBd.ttf"
"

SectionsWhereChangeExtendedEpgToFullEPG="
"ChannelSelection"
"ChannelSelectionRadio"
"EPGSelection"
"EPGSelectionMulti"
"GraphMultiEPG"
"

SectionsWhereChangeServiceDescriptionColor="
"ChannelSelection"
"ChannelSelectionRadio"
"

foo="$0"
shTMP=${foo%.*}".tmp"
shTXT=${foo%.*}".txt"
shDATE=`date -r $0 +%Y%m%d`

if grep -qs FULL_DESCRIPTION /usr/lib/enigma2/python/Components/Converter/EventName.py; then
	pyHasFullEPG=1
fi

t="\t"
t2="\t\t"
t3="\t\t\t"
n="\n"
AND="\&"
NXT=' \&\#187\; '

[ ! -e "$shTXT" ] && echo -e $t"MD5-ControlSum"$t3"Date-Time"$t"Patched-File">"$shTXT"

spaceN () {
	spaceN="$N"
	while [ ${#spaceN} -le 4 ]; do
		spaceN=\ $spaceN
	done
}

space0 () {
	space0="$oldstr"
	while [ ${#space0} -le 20 ]; do
		space0=$space0\ 
	done
}

AddSed () {
	echo "$N"s?"$oldstr"?"$newstr"?"$SedOption">>"$cFILE".sed
	SedOption=""
	[ "$CrntSCREEN" != "" ] && Info="  ("$CrntSCREEN")" || Info=""
	spaceN
	space0
	echo -e Change line:"$spaceN$Info$n$t$space0" to " $newstr"
}

ScreenSetupNN2HD="\t"'<screen name="Setup" position="240,100" size="800,550">'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<ePixmap pixmap="skin_default/buttons/red.png" position="7,3" size="140,40" alphatest="on" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<ePixmap pixmap="skin_default/buttons/green.png" position="150,3" size="140,40" alphatest="on" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<widget source="key_red" render="Label" position="7,3" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#9f1313" transparent="1" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<widget source="key_green" render="Label" position="150,3" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#1f771f" transparent="1" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<eLabel position="0,0" size="800,2" backgroundColor="grey" zPosition="5" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t\t"'<widget name="config" position="10,45" size="780,500" scrollbarMode="showOnDemand" enableWrapAround="1" />'"\n"
ScreenSetupNN2HD="$ScreenSetupNN2HD""\t"'</screen>'"\n"

DoPatch () {
	[ -e "$cFILE".tmp ] && rm -rf "$cFILE".tmp
	[ -e "$cFILE".sed ] && rm -rf "$cFILE".sed

	echo -e "$n"patching skin: "$cFILE"

	N=0 AddWrapAround=0 ChangeEpgDescription=0 ChangeServiceDescriptionColor=0 SkipNextExtendedDescription=0
	EventTitleColor0="" EventTitleColor1="" ChangeVerticalPositionVolumeMute="" ChangeServiceList=0 SetupIsReplaced=0
	case "$cFILE" in
		*/newnigma2-HD/*)
			#EventTitleColor0=\\\#918848
			#EventTitleColor0=\\\#948f45
			EventTitleColor0=\\\#a08f5a
			#EventTitleColor0=\\\#aea63e
			#EventTitleColor0=\\\#bcb343
			#EventTitleColor0=\\\#c6bf4a
			EventTitleColor1=\\\#fcc000
			ChangeVerticalPositionVolumeMute=100
		;;
	esac

	while read line; do
	  N=$((N+1))
	  case "$line" in
		"</screen"*|"</fonts>")
			CrntSCREEN="" AddWrapAround=0 ChangeEpgDescription=0 ChangeServiceDescriptionColor=0
			SkipNextExtendedDescription=0 IncreaseSizeVtill=0 RemoveDoubleTitle=0 ChangeTitleTo=""
			ChangeServiceList=0;;
		"<screen "*)
			CrntSCREEN=`echo "$line"|sed -e 's/.* name="//' -e 's/".*//'`
			for Check in $SectionsWhereAddWrapAround; do
				if [ "$Check" = "$CrntSCREEN" ]; then
					AddWrapAround=1
				fi
			done
			for Check in $SectionsWhereChangeServiceDescriptionColor; do
				if [ "$Check" = "$CrntSCREEN" ] && [ "$EventTitleColor0$EventTitleColor1" ]; then
					ChangeServiceDescriptionColor=1
				fi
			done
			case "$CrntSCREEN" in
				"ChannelContextMenu")
					IncreaseSizeVtill=400
					SIZE=`echo "$line"| sed -e 's/.*size="//' -e 's/".*//'`
					SizeH=`echo "$SIZE"| sed -e 's/,.*//'`
					SizeV=`echo "$SIZE"| sed -e 's/.*,//'`
					if [ "$SizeV" -lt "$IncreaseSizeVtill" ]; then
						oldstr=size\=\""$SIZE"\"
						newstr=size\=\""$SizeH"\,"$IncreaseSizeVtill"\"
						AddSed
						IncreaseSizeVtill=360
					else
						IncreaseSizeVtill=0
					fi
				;;
				"menu_setup")
					ChangeTitleTo='Main menu'"$NXT"Setup;;
				"menu_information")
					ChangeTitleTo='Main menu'"$NXT"Information;;
				"menu_scan")
					ChangeTitleTo='Main menu'"$NXT"Setup"$NXT"'Service Searching';;
				"menu_system")
					ChangeTitleTo='Main menu'"$NXT"Setup"$NXT"System;;
				"menu_harddisk")
					ChangeTitleTo=Harddisk;;
				"menu_shutdown")
					ChangeTitleTo='Standby / Restart';;
				"Volume"|"Mute")
					if [ "$ChangeVerticalPositionVolumeMute" ]; then
						POS=`echo "$line"| sed -e 's/.*position="//' -e 's/".*//'`
						PosH=`echo "$POS"| sed -e 's/,.*//'`
						PosV=`echo "$POS"| sed -e 's/.*,//'`
						if [ "$PosV" -lt "$ChangeVerticalPositionVolumeMute" ]; then
							oldstr=position\=\""$POS"\"
							newstr=position\=\""$PosH"\,"$ChangeVerticalPositionVolumeMute"\"
							AddSed
						fi
					fi
				;;
				"ServiceScan")
					ChangeServiceList=1
				;;
				"orig_Setup")
					SetupIsReplaced=1
				;;
			esac
			if [ `echo "$line"| grep -c wfNoBorder` -eq "0" ]; then
				RemoveDoubleTitle=1
			fi
			if [ "$RemoveDoubleTitle" = "1" ] && [ "$ChangeTitleTo" ]; then
				Check=`echo "$line"| grep title=| sed -e s/.*title=\"// -e 's/".*//' -e 's/\#/\\\#/g' -e 's/\&/\\\&/g' -e 's/\;/\\\;/g'`
				if [ ! "$Check" ]; then
					oldstr=\>
					newstr=\ title\=\""$ChangeTitleTo"\"\&
					AddSed
				elif [ "$Check" != "$ChangeTitleTo" ]; then
					oldstr=title\=\""$Check"\"
					newstr=title\=\""$ChangeTitleTo"\"
					AddSed
				fi
			fi
		;;
		*"index 1 is the nim name"*)
			Check=`echo "$line"| sed -e 's/.*size = (//' -e 's/,.*//'`
			if [ "$Check" -lt 580 ]; then
				oldstr=size\ \=\ \("$Check"
				newstr=size\ \=\ \(580
				AddSed
			fi
		;;
		"<font "*)
			CrntSCREEN=Fonts
			ChangeFONT=0 CrntFILE=`echo "$line"|sed -e 's/.* filename="//' -e 's/".*//'`
			for Check in $ReplaceFonts; do
				if [ "$Check" = "$CrntFILE" ]; then
					ChangeFONT=1
				fi
			done
			if [ "$ChangeFONT" = "1" ]; then
				FileOrig=`echo "$line"| grep filename_orig=`
				if [ -e "$FileOrig" ]; then
					ChangeFONT=0
				fi
			fi
		;;
		'<convert type="EventName">Description'*)
			SkipNextExtendedDescription=1
		;;
		'<convert type="EventName">ExtendedDescription'*)
			if [ "$SkipNextExtendedDescription" = "1" ]; then
				SkipNextExtendedDescription=0
			elif [ "$pyHasFullEPG" = "1" ]; then
				for Check in $SectionsWhereChangeExtendedEpgToFullEPG; do
					if [ "$Check" = "$CrntSCREEN" ]; then
						ChangeEpgDescription=1
					fi
				done
			fi
		;;
		"<widget "*)
			if [ "$ChangeServiceDescriptionColor" = "1" ]; then
				Check=`echo "$line"|sed -e 's/.*name="//' -e 's/".*//'`
				if [ "$Check" = "list" ]; then
					ChangeServiceDescriptionColor=2
				fi
			fi
			if [ "$RemoveDoubleTitle" = "1" ]; then
				if [ `echo "$line"| grep -c source=\"title\"` -gt "0" ] || [ `echo "$line"| grep -c source=\"Title\"` -gt "0" ]; then
					oldstr=\<widget
					newstr=\<\!\-\-\ widget
					AddSed
					oldstr=\>
					newstr=\ \-\-\>
					AddSed
					RemoveDoubleTitle=0
				fi
			fi
		;;
	  esac
	  if [ "$ChangeServiceDescriptionColor" = "2" ]; then
		for strParam in colorServiceDescription= colorServiceDescriptionSelected= colorEventProgressbarBorder= colorEventProgressbarBorderSelected=; do
			case "$strParam" in
				*Selected=)	EventTitleColor=$EventTitleColor1;;
				*)		EventTitleColor=$EventTitleColor0;;
			esac
			Check=`echo "$line"| grep "$strParam"| sed -e s/.*"$strParam"\"// -e 's/".*//' -e 's/\#/\\\#/g'`
			if [ ! "$Check" ]; then
				Check=`echo "$line"| grep \/\>`
				if [ "$Check" ]; then
					oldstr=\/\>
					newstr=\ "$strParam"\""$EventTitleColor"\"\&
					AddSed
				fi
			else
				if [ ! "$Check" = "$EventTitleColor" ]; then
					oldstr="$strParam"\""$Check"\"
					newstr="$strParam"\""$EventTitleColor"\"
					AddSed
				fi
			fi
		done
		ChangeServiceDescriptionColor=0
	  elif [ "$ChangeEpgDescription" = "1" ]; then
		oldstr=ExtendedDescription
		newstr=FullDescription
		AddSed
		ChangeEpgDescription=0
	  elif [ "$ChangeFONT" = "1" ]; then
		oldstr=filename=
		newstr=filename=\"nmsbd.ttf\"\ filename_orig=
		AddSed
		ChangeFONT=0
	  elif [ "$ChangeServiceList" = "1" ]; then
		case "$line" in
		"<widget name"*servicelist*)
			if `echo "$line"| grep -qs selectionDisabled`; then
				oldstr=selectionDisabled
				newstr=zPosition=\"1\"\ backgroundColor=\"background\"\ transparent=\"1\"\ scrollbarMode=\"showOnDemand\"\ enableWrapAround
				AddSed
			fi
			ChangeServiceList=0
		;;
		esac
	  elif [ "$AddWrapAround" = "1" ]; then
	    case "$line" in
	    "<widget "*)
		wRender=`echo "$line"| grep render=| sed -e 's/.*render="//' -e 's/".*//'`
		[ ! "$wRender" ] && wRender=missing
		case "$wRender" in
		#Label|Pig);;
		#*)
		Listbox|missing)
		SIZE=`echo "$line"| grep size=| sed -e 's/.*size="//' -e 's/".*//'`
		SizeH=`echo "$SIZE"| sed -e 's/,.*//'`
		SizeV=`echo "$SIZE"| sed -e 's/.*,//'`
		if [ "$SizeV" -ge 170 ]; then
		   Check=`echo "$line"| grep name=| sed -e 's/.*name="//' -e 's/".*//'`
		   if [ ! "$Check" = "Preview" ] && [ ! "$Check" = "rc" ]; then
			[ "$SizeV" -lt "$IncreaseSizeVtill" ] && SizeV="$IncreaseSizeVtill"
			Check=`echo "$line"| grep enableWrapAround=| sed -e 's/.*enableWrapAround="//' -e 's/".*//'`
			if [ ! $Check ]; then
				oldstr=size=\""$SIZE"\"
				newstr=size=\""$SizeH"\,"$SizeV"\"\ enableWrapAround=\"1\"
				AddSed
				IncreaseSizeVtill=0
			elif [ ! "$Check" = "1" ]; then
				oldstr=enableWrapAround=\""$Check"\"
				newstr=enableWrapAround=\"1\"
				AddSed
			fi
			if [ "$IncreaseSizeVtill" -gt "0" ]; then
				oldstr=size=\""$SIZE"\"
				newstr=size=\""$SizeH"\,"$SizeV"\"
				AddSed
				IncreaseSizeVtill=0
			fi
			AddWrapAround=0
		   fi
		fi
		;;
		esac
	    ;;
	    esac
	  fi
	done < $cFILE

	if [ -e "$cFILE".sed ]; then
		if [ "$SetupIsReplaced" = "0" ]; then
		   case "$cFILE" in
			*/newnigma2-HD/*)
				echo replace screen "Setup"
				echo s?^[[:space:]]\<screen\ name=\"Setup\"?$ScreenSetupNN2HD"$t"\<screen\ name=\"orig_Setup\"?>>"$cFILE".sed
			;;
		   esac
		fi
		echo s?^[[:space:]][[:space:]]\ \ \ \ ?"$t3"?>>"$cFILE".sed
		echo s?^[[:space:]]\ \ \ \ ?"$t2"?>>"$cFILE".sed
		echo s?^\ \ \ \ ?"$t2"?>>"$cFILE".sed
		echo s?^\ \ ?"$t"?>>"$cFILE".sed
		echo s?\ \ ?\ ?g>>"$cFILE".sed
		echo s?[[:space:]]\ ?"$t"?g>>"$cFILE".sed
		sed -f "$cFILE".sed "$cFILE">"$cFILE".tmp
		if [ -s "$cFILE".tmp ]; then
			rm -rf "$cFILE"
			mv "$cFILE".tmp "$cFILE"
		else
			echo failed!!!
		fi
	fi
}


UpdateMD5list () {
	MD5_CRNT=`md5sum $cFILE| awk {'print $1'}`
	if grep -qs " $cFILE " $shTXT; then
		rm -f "$shTMP"
		sed s#.*" $cFILE ".*## $shTXT| sed '/^$/d'>"$shTMP"
		mv "$shTMP" "$shTXT"
	fi
	echo "$MD5_CRNT "`date +%Y.%m.%d.\ %H:%M:%S`" $cFILE ">>"$shTXT"
}

for cFILE in /usr/share/enigma2/skin.xml /usr/share/enigma2/*/skin.xml; do
  if [ -e "$cFILE" ]; then
	MD5_OLD=`grep " $cFILE " "$shTXT"| awk {'print $1'}`
	MD5_CRNT=`md5sum $cFILE| awk {'print $1'}`
	DoPatch=0
	for bcFile in ${cFILE%.*}"_orig_"*".xml"; do
		if [ -e "$bcFile" ]; then
			NewBcFile="$cFILE"_orig_`echo ${bcFile%.*}| sed -e s?.*_orig_??`
			[ -e "$NewBcFile" ] && rm -rf "$bcFile" || mv "$bcFile" "$NewBcFile"
		fi
	done
	if [ ! "$MD5_OLD" = "$MD5_CRNT" ]; then
		DoPatch=1
	else
		LastBcFile=""
		for bcFile in $cFILE"_orig_"*; do
			[ -e "$bcFile" ] && LastBcFile="$bcFile"
		done
		if [ "$LastBcFile" ]; then
			fDATE=`date -r $cFILE +%Y%m%d`
			if [ "$shDATE" -gt "$fDATE" ]; then
				txDATE=`grep " $cFILE " "$shTXT"| awk {'print $2'}| sed 's?\.??g'`
				[ "$fDATE" = "$txDATE" ] && cp $LastBcFile $cFILE && DoPatch=1
			fi
		fi
	fi
	if [ "$DoPatch" = "1" ]; then
		[ ! -e $cFILE"_orig_"`date +%y%m%d` ] && cp $cFILE $cFILE"_orig_"`date +%y%m%d`
		MD5_OLD=00
		for bcFile in $cFILE"_orig_"*; do
			MD5_CRNT=`md5sum $bcFile| awk {'print $1'}`
			[ "$MD5_OLD" = "$MD5_CRNT" ] && rm -rf "$bcFile" || MD5_OLD="$MD5_CRNT"
		done
		DoPatch
		UpdateMD5list
	fi
  fi
done

exit 0
